\ Copyright 1997 - HanSoft & Partners
\ Portions by Leo Brodie
\ Tic Tac Toe

\ Typical usage:
\       page tictactoe

false constant ANS

ANS [IF]
256 constant /string-space
s" easy4th.f" included
[THEN]

: input#
  begin
    refill drop bl word number         ( n )
    dup (error) <>                     ( n f )
    dup 0=                             ( n f -f )
    if swap drop then                  ( f | n f )
  until ;                              ( input routine )
                                       \ convert to display coordinates
table convert 1 , 2 , 3 , 6 , 9 , 8 , 7 , 4 , 5 ,
: normal 1- convert swap th @' ;

9 string board                         \ Starting Forth page 214

: clear board 9 0 fill ;
: square board chars + ;
: bar ." | " ;
: dashes cr ." ---------" cr ;

: .box
  square c@ dup 0=
  if
    2 spaces
  else
    dup 1 =
    if ." X " else ." O " then
  then drop ;

: display cr
  9 0 do
    I if
      I 3 mod 0=
      if dashes else bar then
    then
    I .box
  loop cr ;

: play 1- 0 max 8 min square c! ;
: x! normal 1 swap play display ;
: o! normal 2 swap play ;

: fnM                                  ( n1 n2 -- n3)
  + 1- 8 mod 1+
;

: EndGame                              ( n --)
  x!                                   \ final computer move
  cr ." You lose." cr                  \ since you've lost
  quit
;

: Player                               ( c1 -- p1)
  x!                                   \ computers move
  cr
  ." 123" cr
  ." 894" cr
  ." 765 Your move: " input# dup
  o!                                   \ my move
;
                                       \ calculate computer move
: Computer                             ( p1 n1 -- c2 c2)
  fnM                                  ( c2)
  dup                                  ( c2 c2)
;

: EndGame?                             ( p1 c2 n1)
  Computer                             ( p1 c3 c3)
  rot <>                               ( c3 f)
  if                                   \ is player losing?
    EndGame                            \ if so, end game
  else
    drop                               \ else drop the value
  then
;
                                       \ computer/player turn
: Moves                                ( n1 n2 -- n1)
  Computer                             ( c1 c1)
  Player                               ( c1 p1)
  over 4 EndGame?                      ( c1)
;

: 1stMove?                             \ was the first move fatal?
   swap 2 mod 0=                       ( c3 f)
   if                                  ( c3)
     7 fnM                             ( c4)
     EndGame
   then                                ( c3)
;
                                       \ now play the game!
: TicTacToe
   clear 9                             ( c1)
                                       \ computer takes centre
   Player                              ( p1)
   dup                                 ( p1)
                                       \ store the first move
   1 Moves                             \ play second move
   2 Moves                             \ play third move
   1stMove?                            \ was 1st move fatal?
   3 Moves                             \ play fourth move

   6 fnM x!                            \ nobody wins
   cr ." It's a draw." cr
;

ANS [NOT] [IF] TicTacToe [THEN]
