\ 4tH template for conversion utilities
\ Copyright 2002,2003 - Hansoft & Partners

\ This file is not intended for standalone use.
\ You will have to define the following words:

\ Usage       ( --)   : abort" Your error message"   
\ PreProcess  ( --)   : Actions before the file is read      (optional)
\ Read-file   ( -- f) : How to read the file, e.g. refill
\ Process     ( --)   : What to do after each Read-file
\ PostProcess ( --)   : Actions after the file has been read (optional)

\ Has Usage been defined? If not, abort!
[DEFINED] Usage [NOT] [IF]
[ABORT] [THEN]

\ Has Read-File been defined?
[DEFINED] Read-File [NOT] [IF]
[ABORT] [THEN]

\ Has Process been defined?
[DEFINED] Process [NOT] [IF]
[ABORT] [THEN]

: CloseFiles close close ;             ( h h --)
                                       \ open a file and abort on error
: (open)                               ( m n -- h)
  args >r r@ count rot open dup 0=     ( h f)
  if                                   ( h)
     stdout use                        \ force use of stdout
     ." Cannot open "                  \ write message
     r> count type cr abort            \ write filename
  else                                 ( h)
     dup use r> drop                   \ use file, clear return stack                 
  then                                 ( h)
;
                                       ( -- h h)
: OpenFiles                            \ open input and output files
  argn 3 < Usage                       \ issue message if error
  input  1 (open)                      \ open the input file                
  output 2 (open)                      \ open the output file
;

: ProcessFile                          \ process the input file line by line
[DEFINED] PreProcess [IF]
  PreProcess                           \ do any preprocessing
[THEN]
  begin
    Read-file                          \ read the file
  while
    Process                            \ process the line or buffer
  repeat
[DEFINED] PostProcess [IF]
  PostProcess                          \ do any postprocessing
[THEN]
;

: Convert OpenFiles ProcessFile CloseFiles ;

Convert

