/*       cmds_4th.h

         Command definitions for portable Forth compiler.

         Copyright (c) HanSoft 1994,2002
         All Rights Reserved.
*/

#ifndef _CMD_4TH_H
#define _CMD_4TH_H

#define NOOP       0
#define EXECUTE    1
#define CR         2
#define SPACES     3
#define EMIT       4
#define PRINT      5
#define DOT        6
#define FETCH      7
#define STORE      8
#define CATCH      9

#define CAUGHT    10
#define PLUS      11
#define MINUS     12
#define MUL       13
#define DIV       14
#define MOD       15
#define SWAP      16
#define DUP       17
#define OVER      18
#define ROT       19

#define DROP      20
#define EQ        21
#define LT        22
#define GT        23
#define GE        24
#define LE        25
#define NE        26
#define INVERT    27
#define LT0       28
#define GT0       29

#define BRANCH0   30
#define BRANCH    31
#define FETCHPRM  32
#define AND       33
#define OR        34
#define XOR       35
#define SHIFT     36
#define ABS       37
#define NEGATE    38
#define QUIT      39

#define MIN       40
#define MAX       41
#define RPUT      42
#define RGET      43
#define RCOPY     44
#define NE0       45
#define EQ0       46
#define ACCEPT    47
#define HEX       48
#define OCTAL     49

#define DECIMAL   50
#define RPFETCH   51
#define SPFETCH   52
#define THROW     53
#define CLSPAREN  54
#define INC       55
#define DEC       56
#define ARGS      57
#define ARGN      58
#define LEFT2     59

#define RIGHT2    60
#define LITERAL   61
#define QDO       62
#define DO        63
#define LOOP      64
#define PLOOP     65
#define LEAVE     66
#define FCLOSE    67
#define FOPEN     68
#define USE       69

#define ADDSTORE  70
#define SLASHMOD  71
#define STARSLSH  72
#define STSLHMOD  73
#define CMOVE     74
#define EXIT      75
#define WAIT      76
#define RCOPY3    77
#define DOTR      78
#define NUMBER    79

#define VARIABLE  80
#define RANDOM    81
#define TRAILING  82
#define HI        83
#define FIRST     84
#define LAST      85
#define CALL      86
#define REFILL    87
#define CFETCH    88
#define CSTORE    89

#define TYPE      90
#define FILL      91
#define COUNT     92
#define SKIP      93
#define TOKEN     94
#define LSHARP    95
#define SHARP     96
#define RSHARP    97
#define SHARPS    98
#define SIGN      99

#define HOLD     100
#define TO       101
#define VALUE    102
#define TIME     103
#define COPY     104
#define SQUOTE   105

/* ranges */
#define LastWord4th  SQUOTE
#define LastMsg4th   M4DUPNAM

/* flags */
#define F_T        1L
#define F_F        0L

/* file modes */
#define F4_READ      0L
#define F4_WRITE     1L
#define F4_TEXT      2L
#define F4_APPND     4L
#define F4_PIPE      8L

/* header */
#define Version4th   0x33D
#define App4th       0L

/* compiler */
#define LINKSIZ      64
#define SYMLEN       16

/* interpreter */
#define STACKSIZ     512
#define TIBSIZ       256
#define PADSIZ       256
#define VAR4TH         3
#define RNDMASK    32767
#define MAXDEVS        8
#define PIPEWAIT 102400L

/* load+save */
#define HMASK   UCHAR_MAX
#define HBITS   CHAR_BIT
#define HNTINY  SCHAR_MAX
#define HNSMALL SHRT_MAX
#define HSPOS   0
#define HSNEG   1
#define HCCELL  0
#define HCSIGN  1
#define HCBYTE  2
#define HCSHRT  4
#define HCZERO  8
#define HCONE  16

/* generation */
#define UNITSLINE 9
#define DICTSLINE 3

/* no not change */
#define TIB    0
#define PAD    TIBSIZ
#define S0     0
#define R0     (STACKSIZ-1)

#endif


