/*
+-------+-----------------+------+-----------------+-------+-----------------+
|Program| COMP_4TH.C      |Header| 4TH.H           |Library| CEXT            |
+-------+-----------------+------+-----------------+-------+----------+------+
|HISTORY                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Turbo C V2.0 version                             | HanSoft          |181094|
| DPX/2 340 version                                | HanSoft          |181094|
| Coherent V4.2 version                            | HanSoft          |201094|
| DJGPP V2.72 version                              | HanSoft          |230597|
| Linux 2.2.10 version                             | HanSoft          |170600|
+--------------------------------------------------+------------------+------+
|MODIFICATION LOG                                  |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Added J, I', /MOD, * /, * /MOD, FAST, SLOW       | HanSoft          |191094|
| Added hex check on resolving symbols             | HanSoft          |191094|
| Added .R, TH, BASE@, USER@, LIMIT@, STACK@,      | HanSoft          |201094|
| Added WIDTH@, V0@, SP@, RP@, VARIABLE, ALLOT     | HanSoft          |201094|
| Redesigned building symboltable                  | HanSoft          |201094|
| Added TICK, COMMA, EXECUTE, ABORT, EXIT, CREATE  | HanSoft          |241094|
| Added C@, WAIT; removed resolving LITERALS       | HanSoft          |241094|
| Redesigned resolving symbols                     | HanSoft          |241094|
| Added OCTAL, DECIMAL, HEX in second pass         | HanSoft          |241094|
| Removed LITERAL resolving code at VARIABLE       | HanSoft          |251094|
| Completely restructured substitution algorhythm  | HanSoft          |251094|
| Added /. and /.R commands                        | HanSoft          |271094|
| Added TIME and RANDOM commands                   | HanSoft          |161194|
| Merged pass1_4th() and pass2_4th()               | HanSoft          |220295|
| Modified documentation; added some statics       | HanSoft          |010395|
| Fixed first pass bug and PRINT bug               | HanSoft          |140395|
| Removed V0@, changed , to C,                     | HanSoft          |180395|
| Merged GetFAddr() and GetBAddr() to GetAddr()    | HanSoft          |210395|
| GetAddr() now optionally patches target keyword  | HanSoft          |210395|
| Removed LABEL, DEFINE and CREATE                 | HanSoft          |210395|
| Fixed ProgSiz4th check bug                       | HanSoft          |210395|
| Cut out some unneeded assignments in 1st pass    | HanSoft          |240395|
| Changed LIMIT@ to VARS, USER@ to USER            | HanSoft          |310395|
| Changed STACK@ to STACK, C, to ,                 | HanSoft          |310395|
| Added C, , HERE, ASCII, changed WIDTH@ to LENGTH | HanSoft          |310395|
| Completely redesigned the object format          | HanSoft          |140495|
| Removed LITERAL, PENDING, TICK, SLOW and FAST    | HanSoft          |140495|
| Removed CCOMMA and COMMENT, redefined COMMA      | HanSoft          |140495|
| First version of 4tH V2.0; changed C@ to ,@      | HanSoft          |190495|
| Removed VARDECL from VARIABLE code               | HanSoft          |200495|
| Fixed some very minor errors                     | HanSoft          |200495|
| Fixed stringarea bug; added static to functions  | HanSoft          |210495|
| Fixed bug in ASCII                               | HanSoft          |210495|
| Added R@, >> & <<, removed VALUE, changed STACK  | HanSoft          |250495|
| Fixed StringArea bug; changed LENGTH to WIDTH@   | HanSoft          |280495|
| Removed INPUT, added QUERY and other text words  | HanSoft          |280495|
| Added !IN                                        | HanSoft          |290495|
| Changed all CONSTANT to LITERAL; added SYMWORDS  | HanSoft          |300495|
| Removed /., /.R; added #, #S, <#, #>, HOLD & SIGN| HanSoft          |010595|
| Added COPY; TICK now also compiles VARIABLE      | HanSoft          |020595|
| TICK now works like Forth                        | HanSoft          |030595|
| TICK now only works with COLON defs again        | HanSoft          |040595|
| Added ,", -TRAIL, >TTY, >FILE, ConstList         | HanSoft          |060995|
| Added GetSimpleConst(); removed strcalc() words  | HanSoft          |060995|
| Renamed WIDTH@ to WIDTH; some cosmetic changes   | HanSoft          |070995|
| Removed NEG, changed #define into NEGATE         | HanSoft          |080995|
| Added [BINARY] operator                          | HanSoft          |080995|
| Removed LESS, KILL, LEFT, RIGHT, !IN             | HanSoft          |110995|
| Added SHIFT, >IN                                 | HanSoft          |110995|
| Added EXPECT; new Version4th included            | HanSoft          |140995|
| Added TTY>, FILE>, #TIB, #PAD                    | HanSoft          |150995|
| Added INFILE, OUTFILE                            | HanSoft          |180995|
| Added -N, +N and DEPTH                           | HanSoft          |210995|
| Updated errors; changed -N/+N to -LIMIT/+LIMIT   | HanSoft          |220995|
| Added ParseStrings(), ParseText(), MoveString()  | HanSoft          |020296|
| Added GetNextWord(); deleted others              | HanSoft          |020296|
| Fixed some declarations (ANSI_C, static)         | HanSoft          |070296|
| Added MakeLink(), MarkLink(), PairLink()         | HanSoft          |080296|
| Removed GetAddr(), FillWord() and 2nd pass       | HanSoft          |080296|
| Added FALSE, TRUE, new BRANCH-constructs         | HanSoft          |080296|
| Replaced RETURN with EXIT in ;                   | HanSoft          |090296|
| Added cell support and NE0; fixed some minor bugs| HanSoft          |100296|
| Checks for unique name; moved WordList           | HanSoft          |110296|
| Moved ConstList to GetSimpleConst()              | HanSoft          |110296|
| Added support for Hcode and tok                  | HanSoft          |120296|
| Added HI, LO, ALLOCATE; changed #LINE to L/SCR   | HanSoft          |140296|
| Fixed bug when early errors occur                | HanSoft          |160296|
| Added TO and VALUE                               | HanSoft          |240296|
| Fixed some minor bugs in strings; changed TICK   | HanSoft          |240296|
| Added aliases CHAR, CHAR+, CHAR-, CELL+, CELL-   | HanSoft          |250296|
| Added dummies CHARS and CELLS                    | HanSoft          |250296|
| Changed ," to c" ; added aliases INVERT and R@   | HanSoft          |040396|
| Removed LINE, C/L, L/SCR; changed ALLOCATE       | HanSoft          |050396|
| Changed VARS to LAST, USER to FIRST; added VARS  | HanSoft          |050396|
| Added aliases MOVE, LSHIFT, ['] and [CHAR]       | HanSoft          |100396|
| Added dummies ALIGN and ALIGNED                  | HanSoft          |100396|
| Changed header to check alignment                | HanSoft          |130396|
| Fixed bug; no error when no program              | HanSoft          |130396|
| Changed InitObject() to new standards            | HanSoft          |100496|
| Added GetDeclaration(); changed main()           | HanSoft          |180496|
| Renamed SearchSymTable() to GetSymbolTable()     | HanSoft          |180496|
| Fixed silly bug in DoBinary()                    | HanSoft          |060596|
| Added constant APPL                              | HanSoft          |290796|
| Changed APPL to APP                              | HanSoft          |100996|
| Added AllocResource() and AbortCompile()         | HanSoft          |021096|
| Rewrote sections for new Hcode format            | HanSoft          |021096|
| Added ReallocSegs(); fixed minor bugs            | HanSoft          |031096|
| Added NULL check in ParseText()                  | HanSoft          |081096|
| Changed GetDeclaration() to GetImmediate()       | HanSoft          |081096|
| Changed '@ to @'; changed allocation order       | HanSoft          |101096|
| Removed ALLOCATE, added STRING and AT            | HanSoft          |211096|
| Renamed DoAllocate() to DoString()               | HanSoft          |211096|
| Changed DoConstant() a little                    | HanSoft          |211096|
| Renamed GetSymbolTable() to GetSymbol()          | HanSoft          |301096|
| Renamed GetSimpleWord() to GetWord()             | HanSoft          |301096|
| Renamed GetSimpleConst() to GetConstant()        | HanSoft          |301096|
| Added NOT_FOUND; changed DoValue() and DoTick()  | HanSoft          |301096|
| Changed GetWord(), GetImmediate(), GetConstant() | HanSoft          |301096|
| Added COMPILE, , changed +LIMIT to LIMIT         | HanSoft          |201196|
| Changed -LIMIT to (ERROR), added S0 and R0       | HanSoft          |201196|
| Removed ABORT, added SP! and RP!                 | HanSoft          |201196|
| Added F_T and F_F                                | HanSoft          |031296|
| Added CLOSEIO                                    | HanSoft          |061296|
| Fixed bug in ParseText(); last word is ignored   | HanSoft          |060297|
| Updated errors; removed M4INTERR                 | HanSoft          |060297|
| Removed >TTY, TTY>, >FILE, FILE>, INFILE, OUTFILE| HanSoft          |280297|
| Removed CLOSEIO; added FILE, TTY, INPUT, OUTPUT  | HanSoft          |280297|
| Added OPEN, CLOSE                                | HanSoft          |280297|
| Fixed tiny bug in AbortCompile() K&R header      | HanSoft          |150397|
| Removed COMPILE,                                 | HanSoft          |180397|
| Removed stpncpy() because of Linux confict       | HanSoft          |080497|
| Added RESULT variable                            | HanSoft          |100497|
| Added ASSERT, ASSERT( and )                      | HanSoft          |110497|
| Fixed bug in ParseStrings()                      | HanSoft          |110497|
| Added ParseDefines(); fixed bug: init globals    | HanSoft          |120497|
| Changed ASSERT to [ASSERT]; changed DoAssert()   | HanSoft          |170497|
| Added THROW, HANDLER; removed SP!, RP!, S0, R0   | HanSoft          |170497|
| Changed M4TABFUL to M4BADOBJ                     | HanSoft          |200497|
| Added DecodeSymbol(), DoArray(); removed ALLOT   | HanSoft          |220597|
| Removed DoAllot(); added .(, ", TABLE, ARRAY     | HanSoft          |220597|
| Removed AT; changed ParseStrings(), DoString()   | HanSoft          |220597|
| Added support for LOCAL_H; fixed ASCII bug       | HanSoft          |220597|
| Changed AddSymbol(); added DoRecurse(), RECURSE  | HanSoft          |220597|
| Fixed bug in ParseText()                         | HanSoft          |230597|
| Cleaned up code in ParseText()                   | HanSoft          |240597|
| Added ARGS and ARGN                              | HanSoft          |240797|
| Removed <limits.h>                               | HanSoft          |250797|
| Added [IF] and [THEN]                            | HanSoft          |260897|
| Added SkipSource() and DecodeLiteral()           | HanSoft          |260897|
| Fixed serious bug in ParseStrings()              | HanSoft          |270897|
| Added S>D and ABORT                              | HanSoft          |310897|
| Added :NONAME, DoNoName() and DecodeWord()       | HanSoft          |130997|
| Added ParseDirective(); removed ParseDefines()   | HanSoft          |170997|
| Changed ParseStrings() and ParseText()           | HanSoft          |170997|
| Added FreeResource() to minimize memory usage    | HanSoft          |250997|
| Removed -TRAIL; added TUCK, NIP, +UNDER, RSHIFT  | HanSoft          |250997|
| Added -TRAILING, CMOVE>, BLANK and ERASE         | HanSoft          |250997|
| Changed char[] to *char in ...4th structs        | HanSoft          |250997|
| Changed ? to inline macro; removed I'            | HanSoft          |260997|
| Stripped arguments from MoveString()             | HanSoft          |290997|
| Removed 2+ and 2-; added ?DO and CompileLoop()   | HanSoft          |151097|
| Removed QUERY, added REFILL                      | HanSoft          |311097|
| Removed Forth79 words ASCII, END, ENDIF, MINUS, R| HanSoft          |011197|
| Removed Forth79 word NOT, added D>S              | HanSoft          |011197|
| Changed DoRecurse(), uses the ControlStack now   | HanSoft          |121197|
| Added CATCH and CAUGHT; changed SPACE to macro   | HanSoft          |191197|
| Changed LIMIT to MAX-N, #PAD to /PAD             | HanSoft          |201197|
| Changed #TIB to /TIB, STACK to STACK-CELLS       | HanSoft          |201197|
| Added MAX-RAND; fixed serious bug in searchings  | HanSoft          |201197|
| Changed MAX-RAND from RAND_MAX to RNDMASK        | HanSoft          |221197|
| Removed EasyC syntax                             | HanSoft          |150198|
| Added #!, APPEND, TEXT; changed ReallocSegs()    | HanSoft          |160298|
| Updated version info                             | HanSoft          |180198|
| Added DoSQuote() and S"                          | HanSoft          |200198|
| Fixed minor bug in ReallocSegs()                 | HanSoft          |230198|
| Added DoAdd(), DoMultiply(), DoNot()             | HanSoft          |071298|
| Removed +UNDER                                   | HanSoft          |131099|
| Replaced tok datatype by unit datatype           | HanSoft          |301099|
| Fixed major bug; changed InitObject()            | HanSoft          |111199|
| Global variables are now properly initialized    | HanSoft          |111199|
| Added [=], [ABORT], /CELL and /CHAR              | HanSoft          |170600|
| Fixed some Linux warnings (no need; code is OK)  | HanSoft          |190600|
| Added SKIP, TOKEN; Added DoWord() and DoParse()  | HanSoft          |160201|
| Added PLACE and DoPlace()                        | HanSoft          |290301|
| Added ABORT" and DoAbortQuote()                  | HanSoft          |301101|
| Added PIPE                                       | HanSoft          |230202|
| Added USE, removed TTY and FILE                  | HanSoft          |280202|
| Added DEFER, IS, AS and FILE and DoInitValue()   | HanSoft          |140902|
| Added STDIN, STDOUT                              | HanSoft          |170902|
| Added [NEEDS, MakeRoom(), ScanText(), DoNeeds()  | HanSoft          |240103|
| Rewrote ParseXXXX() functions and ScanText()     | HanSoft          |290103|
| Fixed a few small bugs in DoNeeds() and others   | HanSoft          |300103|
| Updated comments, fixed K&R prototype ScanText() | HanSoft          |020203|
| Changed DoAssert(), added static to MatchName()  | HanSoft          |020203|
| Added SearchDictionary(), [FIND]                 | HanSoft          |050203|
| Changed [FIND] to [DEFINED] (COMUS compatible)   | HanSoft          |120203|
| Removed C", changed DoCQuote() to DoQuote()      | HanSoft          |120203|
+--------------------------------------------------+------------------+------+
|REMARKS                                           |    Programmer    | Date |
+--------------------------------------------------+------------------+------+
| Special thanks to Reuben Thomas for ANSI-C code  | HanSoft          |151199|
+--------------------------------------------------+------------------+------+

  Copyright (C) 1994,2003 J.L. Bezemer

  This file is part of 4tH

  4tH is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


This is the actual 4tH single-pass compiler. It tokenizes all built-in
keywords, resolves jump-addresses and builds the symboltable. It returns
a pointer to the H-code in memory.

Prototype: Hcode* comp_4th (char *Program)
Returns  : a pointer to Hcode on succes; else NULL
Memory   : the size of the source, the size of a dict entry times the number
           of dict entries, a fixed linktable, a dynamic symboltable, an
           object header; most of it is freed or realloced at exit - only
           the resources of the Hcode remain
Example  :


#include "4th.h"
#include <stdlib.h>

#ifndef ARCHAIC
  int main (int argc, char **argv)
#else
  int main (argc, argv) int argc; char **argv;
#endif

begin

  Hcode *object;
  char  *sources;
  size_t fsize;

  if (argc == 2)
    {
      if ((sources = open_4th (argv [1])) == NULL)
         printf ("Loading; \'%s\' does not exist or too large\n", argv [2]);
      else
        {
          object = comp_4th (sources);
          printf ("Compile; word %u: %s\n", object->ErrLine,
                  errs_4th [object->ErrNo]);
          dump_4th (object, stdout, 0, -1);
          return (EXIT_SUCCESS);
        }
    }
  return (EXIT_FAILURE);
}


Input    : None
Output   : depends on program
Related  : dump_4th(), exec_4th()
*/

#ifdef USRLIB4TH
#include <4th.h>
#include <sys/cmds_4th.h>
#else
#include "4th.h"
#include "cmds_4th.h"
#endif

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define LASTW     1                    /* last word compiled */
#define NEXTW     0                    /* next word to be compiled */

#define R_BEGIN   1
#define R_IF      2
#define R_DO      3
#define R_WHILE   4
#define R_COLON   5

#define W_SEARCH  0
#define W_EXEC    1

#define MISSING   (-1)
#define FOUND     (-2)

#define WHITE     "\x4\x1a\x9\xa\xd\x20"

typedef char ref;                      /* reference link table */

typedef struct {
  ref Mark;                            /* type of conditional */
  int Address;                         /* address of conditional */
} Link;

typedef struct {
  unit Token;                          /* compiled token */
  cell Value;                          /* compiled argument */
  char Name [SYMLEN];                  /* name of symbol */
} Symbol;

typedef struct {
  char *Prev;                          /* points to previously parsed word */
  char *Curr;                          /* points to currently parsed word */
  long  Next;                          /* start of text to be parsed */
  long  End;                           /* end of file (without terminator) */
} ParseRegs;

typedef struct {
  char        Plen;                    /* length of name */
  char       *Pname;                   /* name of symbol */
  signed char PnoSymbols;              /* number of symbols */
  signed char PnoWords;                /* number of tokens */
  char       *Pdelimit;                /* string delimiter */
} Parse4th;

typedef struct {
   char  Wlen;                         /* length of symbol */
   char *Wname;                        /* name of symbol */
   unit  Wtok;                         /* 4th token of symbol */
} Word4th;

typedef struct {
   char  Clen;                         /* length of symbol */
   char *Cname;                        /* name of symbol */
   cell  Cval;                         /* 4th value of symbol */
} Const4th;

typedef struct {
   char   Ilen;                        /* length of symbol */
   char  *Iname;                       /* name of symbol */
#ifdef ARCHAIC
   void (*Ifun) ();                    /* 4th function (K&R) */
#else
   void (*Ifun) (void);                /* 4th function (ANSI) */
#endif
} Immed4th;

static char   *Cursor;                 /* word cursor */
static char   *CurrentWord;            /* word currently evaluated */
static char    Assert;                 /* assertion turned off */
static int     Base;                   /* holds the radix to convert nums */
static int     ToCS;                   /* top of Control Stack */
static int     SymTablep;              /* top of symbol table */
static int     SourceSymbols;          /* size of symbol table */
static int     SourceStrings;          /* number of individual strings */
static int     SourceCorrection;       /* correction for word allocation */
static int     CompiledStrings;        /* counts compiled sourcewords */
static Link   *ControlStack;           /* pointer to Control Stack */
static Symbol *SymTable;               /* pointer to symbol table */
static Hcode  *Object;                 /* pointer to program structure */

static void AddSymbol __PROTO((unit Stoken, cell Svalue, char* Sname));
static int  SearchDictionary __PROTO((char* Name, char Action));

/*
This routine compares two strings. Some implementations provide a case
insensitive function like stricmp(). If that is the case, this function
can be used. If such a function is not available, one is provided here.
It returns zero if both strings match and nonzero if they don't.
*/

#ifdef STRICMP
#define MatchName(a,b) stricmp(a,b)
#else
#ifndef ARCHAIC
  static int MatchName (char *str1, char * str2)
#else
  static int MatchName (str1, str2) char *str1; char * str2;
#endif
{
  for (;toupper ((int) *str1) == toupper ((int) *str2); str1++, str2++)
      if (*str1 == '\0') return (0);
  return (toupper ((int) *str1) - toupper ((int) *str2));
}
#endif


/*
This routine is actually a modified version of strpbrk() which keeps
track of the current position and previously parsed strings. The current
position is later used to include files at their proper place. This
function terminates strings and updates all pointers.
*/

#ifndef ARCHAIC
  static char ScanText (char *delim, ParseRegs *Parser)
#else
  static char ScanText (delim, Parser) char *delim; ParseRegs *Parser;
#endif

{
  char *x;

  for (Parser->Prev = Parser->Curr,
       Parser->Curr = Object->StringSeg + Parser->Next;
       Object->StringSeg [Parser->Next] != '\0'; ++Parser->Next)
       for (x = delim; *x != '\0'; ++x)
         if (Object->StringSeg [Parser->Next] == *x)
           {
             Object->StringSeg [Parser->Next++] = '\0';
             return (TRUE);
           }

  return (FALSE);
}


/*
This routine shifts the second part of the original source to the end of the file
*/

#ifndef ARCHAIC
  static void MakeRoom (ParseRegs *Parser, long Included)
#else
  static void MakeRoom (Parser, Included) ParseRegs *Parser; long Included;
#endif

{
  long cnt;                            /* how many chars to be moved */
  long x;                              /* simple counter */
  char *o;                             /* origin */
  char *d;                             /* destination */

  cnt = Parser->End - Parser->Next;
  o = Object->StringSeg + Parser->End;
  Parser->End += Included + 1L;
  d = Object->StringSeg + Parser->End;
                                       /* calculate the offsets */
  for (x = 0; x <= cnt; o--, d--, x++) *d = *o;
  *d = '\n';                           /* terminate the last line */
}


/*
This routine is almost identical to the original open_4th() function. It
determines the length of the file, expands the space allocated to the
source accordingly, moves the contents and reads the file to be included
at the proper place.
*/

#ifndef ARCHAIC
  static void DoNeeds (ParseRegs *Parser)
#else
  static void DoNeeds (Parser) ParseRegs *Parser;
#endif

{
  char *p;                             /* buffer that holds text */
  FILE *SourceFp;                      /* file pointer to textfile */
  long  FileSiz;                       /* length of file */
                                       /* assume we'll have IO errors */
  Object->ErrNo = M4IOERR;             /* open the include file */
  if ((SourceFp = fopen (Parser->Curr, "rb")) != NULL)
     {                                 /* try to find it's length */
       if (! fseek (SourceFp, 0L, SEEK_END))
         if ((FileSiz = ftell (SourceFp)) != -1L)
           if (! fseek (SourceFp, 0L, SEEK_SET))
              {
                if ((p = (char *) realloc (Object->StringSeg, (Parser->End +
                   FileSiz + 2L) * sizeof (char))) == NULL)
                   Object->ErrNo = M4NOMEM;
                else                   /* enlarge the source buffer */
                   {                   /* if ok, use it and move contents */
                     Object->StringSeg = Parser->Prev = Parser->Curr = p;
                     MakeRoom (Parser, FileSiz);
                     if (fread (Object->StringSeg + Parser->Next, sizeof (char),
                        (size_t) FileSiz, SourceFp) == (size_t) FileSiz)
                        Object->ErrNo = M4NOERRS;
                   }                   /* now read the file into place */
              }
       if (fclose (SourceFp)) Object->ErrNo = M4IOERR;
     }                                  /* return current position in buffer */
}


/*
This routine parses a string. Words with strings usually require a
special delimiter. If a string is succesfully parsed, the routine will
return "one string found" and change the pointer Next. If not, ErrNo is
set and the routine returns zero. It also determines whether the "[NEEDS"
directive is called.
*/

#ifndef ARCHAIC
  static char ParseString (ParseRegs *Parser, char *Delimiter)
#else
  static char ParseString (Parser, Delimiter) ParseRegs *Parser; char *Delimiter;
#endif

{
  if (! ScanText (Delimiter, Parser)) Object->ErrNo = M4NOSTR;
  else                                 /* Termination not found */
     {                                 /* Null string found */
       if (strlen (Parser->Curr) == 0) Object->ErrNo = M4NULSTR;
       else
         {
           if (! MatchName ("[NEEDS", Parser->Prev)) DoNeeds (Parser);
           return (1);                 /* Now check for an inclusion.. */
         }                             /* String has been found */
     }

  return (0);
}


/*
This routine checks whether the parsed word requires special action. It can
compile to more or less words, require an entry in the symbol table or have
a string attached.
*/

#ifndef ARCHAIC
  static char ParseDirective (ParseRegs *Parser)
#else
  static char ParseDirective (Parser) ParseRegs *Parser;
#endif

{
  static Parse4th ParseList [] =  {
         { 1, "\"", 0, -1, "\"" },
         { 1, "\'", 0, -1, "" },
         { 1, "\\", 0, -2, "\xa\xd\x4\x1a" },
         { 1, "(" , 0, -2, ")" },
         { 1, "," , 0, -1, "" },
         { 1, ":" , 1, -1, "" },
         { 1, "?",  0,  1, "" },
         { 2, "#!", 0, -2, "\xa\xd\x4\x1a" },
         { 2, ".\"", 0, -1, "\"" },
         { 2, ".(" , 0, -1, ")" },
         { 2, "S\"", 0, -1, "\"" },
         { 2, "TO" , 1, -1, "" },
         { 2, "IS" , 1, -1, "" },
         { 2, "AS" , 1, -1, "" },
         { 3, "S>D", 0, -1, "" },
         { 3, "D>S", 0, -1, "" },
         { 3, "NIP", 0,  1, "" },
         { 3, "[\']", 0, -1, "" },
         { 3, "[=]", 0, -2, "" },
         { 3, "[*]", 0, -2, "" },
         { 3, "[+]", 0, -2, "" },
         { 4, "CHAR", 0, -1, WHITE },
         { 4, "[IF]", 0, -2, "" },
         { 4, "THEN", 0, -1, "" },
         { 4, "TUCK", 0,  1, "" },
         { 4, "WORD", 0,  2, "" },
         { 4, "FILE", 1,  0, "" },
         { 5, "DEFER", 1,  0, "" },
         { 5, "PLACE", 0,  2, "" },
         { 5, "[NOT]", 0, -1, "" },
         { 5, "ALIGN", 0, -1, "" },
         { 5, "PARSE", 0,  1, "" },
         { 5, "CATCH", 0,  1, "" },
         { 5, "SPACE", 0,  1, "" },
         { 5, "ARRAY", 1, -3, "" },
         { 5, "BEGIN", 0, -1, "" },
         { 5, "CELLS", 0, -1, "" },
         { 5, "CHARS", 0, -1, "" },
         { 5, "TABLE", 1, -2, "" },
         { 5, "VALUE", 1, -1, "" },
         { 5, "[HEX]", 0, -1, "" },
         { 5, "BLANK", 0,  1, "" },
         { 5, "ERASE", 0,  1, "" },
         { 6, "RSHIFT", 0, 1, "" },
         { 6, "CREATE", 1, -2, "" },
         { 6, "[THEN]", 0, -1, "" },
         { 6, "[NEEDS", 0, -2, "]" },
         { 6, "STRING", 1, -3, "" },
         { 6, "ABORT\"", 0, 2, "\"" },
         { 6, "[CHAR]", 0, -1, WHITE },
         { 7, "ASSERT(", 0, -1, "" },
         { 7, "[ABORT]", 0, -1, "" },
         { 7, "[OCTAL]", 0, -1, "" },
         { 7, ":NONAME", 0,  1, "" },
         { 7, "ALIGNED", 0, -1, "" },
         { 8, "CONSTANT", 1, -3, "" },
         { 8, "VARIABLE", 1, -2, "" },
         { 8, "[ASSERT]", 0, -1, "" },
         { 8, "[BINARY]", 0, -1, "" },
         { 9, "[DECIMAL]", 0, -1, "" },
         { 9, "[DEFINED]", 0, -1, WHITE },
         { CHAR_MAX, "", 0, 0, "" }
  };

  int x;                               /* simple counter */
  unsigned len = strlen (Parser->Curr);
                                       /* set pointer */
  for (x = 0; len > ParseList [x].Plen; x++);
  for (;len == ParseList [x].Plen; x++)
      if (! MatchName (ParseList [x].Pname, Parser->Curr))
         {                             /* found; now calculate */
           SourceSymbols    += (int) ParseList [x].PnoSymbols;
           SourceCorrection += (int) ParseList [x].PnoWords;
           if (strlen (ParseList [x].Pdelimit) > 0)
              return (ParseString (Parser, ParseList [x].Pdelimit));
           break;                      /* parse string */
         }

  return (0);                          /* no or no valid string */
}


/*
This routine parses the text that is presented to the compiler. It returns
the number of words (Code Segment entries) it has found. 'SourceSymbols'
holds the number of symboltable entries. 'SourceStrings' holds the number
of words in the source; see: GetNextWord().
*/

#ifndef ARCHAIC
  static int ParseText (void)
#else
  static int ParseText ()
#endif

{
  ParseRegs Parser;
  int SourceWords = 0;

  if (Object->StringSeg)               /* If it is a valid pointer */
     {                                 /* While whitespace found */
       for (Parser.Prev = Parser.Curr = Object->StringSeg, Parser.Next = 0,
            Parser.End = strlen (Object->StringSeg);
           (ScanText (WHITE, &Parser)) && (! Object->ErrNo);)
           {                           /* Begin a new string */
             if (strlen (Parser.Curr) > 0)
                {                      /* Is it a definition? */
                  SourceStrings++;
                  SourceStrings += (int) ParseDirective (&Parser);
                }
           }
                                       /* Get last word after WS */
       if (strlen (Parser.Curr) > 0) SourceStrings++;
       SourceWords = SourceStrings + SourceCorrection;
     }                                 /* Calculate number of words */

  if ((SourceWords < 1) && (! Object->ErrNo))
     Object->ErrNo = M4NOPROG;         /* If nothing compiled and no errors */
                                       /* Then there is no real source code */
  return (Object->ErrNo ? 0 : ++SourceWords);
}                                      /* return no. of words, correct lit. */


/*
This routine gets a string from the parsed text. It keeps track of the current
position of the cursor. White spaces are transparantly skipped.
*/

#ifndef ARCHAIC
  static void GetNextWord (void)
#else
  static void GetNextWord ()
#endif

{
  if (CompiledStrings < SourceStrings)
     {                                 /* Skip null strings */
       for (CurrentWord = Cursor; ! *CurrentWord; CurrentWord++);
       Cursor = CurrentWord + (strlen (CurrentWord) + 1);
       CompiledStrings++;              /* String was read */
     }
  else CurrentWord = NULL;             /* return if all strings read */
}


/*
This routine moves the string of any ." and ," command to the top of the
sourcefile and returns the addres where it has been stored
*/

#ifndef ARCHAIC
  static cell MoveString (void)
#else
  static cell MoveString ()
#endif

{
  cell t = (cell) Object->StringSiz;

  strcpy (Object->StringSeg + Object->StringSiz, CurrentWord);
  Object->StringSiz += (strlen (Object->StringSeg + Object->StringSiz) + 1);
  return (t);
}


/*
This word simply compiles Command and Argument at Object->ErrLine.
*/

#ifndef ARCHAIC
  static void CompileWord (unit Command, cell Argument)
#else
  static void CompileWord (Command, Argument) unit Command; cell Argument;
#endif

{
  if (! Object->ErrNo)                    /* No compiling if error */
    {
      if (Object->ErrLine < Object->CodeSiz)
         {
           Object->CodeSeg [Object->ErrLine].Word  = Command;
           Object->CodeSeg [Object->ErrLine++].Value = Argument;
         }
      else Object->ErrNo = M4BADOBJ;
    }
}


/*
This routine searches the symbol table for a certain symbol. If it is
succesful it will return the number of the entry, else MISSING.
*/

#ifndef ARCHAIC
  static int GetSymbol (char *Symbol, char mode)
#else
  static int GetSymbol (Symbol, mode) char *Symbol; char mode;
#endif

{
  int x;

  for (x = 0; x < SymTablep; x++)
      if (! MatchName (SymTable [x].Name, Symbol))
         {
           if (mode == W_EXEC)
              CompileWord (SymTable [x].Token, SymTable [x].Value);
           return (x);
         }

  return (MISSING);
}


/*
This function decodes a word declaration like in 'DEF <str>'. If a name
could be retrieved it returns TRUE. If not, it sets ErrNo and returns FALSE.
*/

#ifndef ARCHAIC
  static char DecodeWord (unsigned ErrCode)
#else
  static char DecodeWord (ErrCode) unsigned ErrCode;
#endif

{
  GetNextWord();
  if (CurrentWord == NULL) Object->ErrNo = ErrCode;
  else return (TRUE);
  return (FALSE);
}


/*
This function decodes a destructive declaration like '<n> DEF'. It checks all
components and returns <n>.
*/

#ifndef ARCHAIC
  static cell DecodeLiteral (void)
#else
  static cell DecodeLiteral ()
#endif

{
  if (Object->ErrLine == 0) Object->ErrNo = M4NODECL;
  else
    {
      if (Object->CodeSeg [Object->ErrLine - 1].Word != LITERAL)
         Object->ErrNo = M4BADLIT;
      else return (Object->CodeSeg [--Object->ErrLine].Value);
    }
  return (CELL_MIN);
}


/*
This function decodes a declaration like '<n> DEF <name>'. It checks all
components, sets CurrentWord to <name> and returns <n>.
*/

#ifndef ARCHAIC
  static cell DecodeSymbol (void)
#else
  static cell DecodeSymbol ()
#endif

{
  cell val = DecodeLiteral ();

  if (! Object->ErrNo)
     if (DecodeWord (M4NODECL)) return (val);

  return (CELL_MIN);
}


/*
This function skips source until the marker CloseWord is found. In order to
allow embedded pairs, the Level is taken into account.
*/

#ifndef ARCHAIC
  static void SkipSource (char *OpenWord, char *CloseWord)
#else
  static void SkipSource (OpenWord, CloseWord) char *OpenWord; char *CloseWord;
#endif

{
  int Level = 0;

  for (;;)                             /* execute at least once */
    {
      if (! DecodeWord (M4NODECL)) break;
      else                             /* if a word is available */
        {                              /* open new pair */
          if (! MatchName (CurrentWord, OpenWord)) Level++;
          if (! MatchName (CurrentWord, CloseWord))
             {
               if (Level) Level--; else break;
             }
        }                              /* stop if closing word found */
    }
}


/*
This word pushes a link on the stack. "mark" contains the reference,
Object->ErrLine is known.
*/

#ifndef ARCHAIC
  static void MarkLink (ref mark)
#else
  static void MarkLink (mark) ref mark;
#endif

{
  if (ToCS < LINKSIZ)
     {
       ControlStack [ToCS].Mark = mark;
       ControlStack [ToCS++].Address = Object->ErrLine - 1;
     }
  else Object->ErrNo = M4NONEST;            /* nesting too deep */
}


/*
This routine is in fact a translation of the Forth word ?PAIRS.
It returns the pushed address, provided the reference in "mark"
is correct.
*/

#ifndef ARCHAIC
  static int PairLink (ref mark)
#else
  static int PairLink (mark) ref mark;
#endif

{
  if (ToCS > 0)
     if (ControlStack [--ToCS].Mark == mark)
        return (ControlStack [ToCS].Address);

  Object->ErrNo = M4NOJUMP;
  return (INT_MIN);
}


/*
This routine makes a backlink. That means the address to be patched
is returned from the stack and points to an already compiled command.
"offset" is needed, because in some conditionals the word has not
been compiled yet (REPEAT).
*/

#ifndef ARCHAIC
  static void MakeLink (ref mark, int offset)
#else
  static void MakeLink (mark, offset) ref mark; int offset;
#endif

{
  int link = PairLink (mark);

  if (! Object->ErrNo)
     Object->CodeSeg [link].Value = Object->ErrLine - offset;
}


/*
This function compiles a string.
*/

#ifndef ARCHAIC
  static void CompileString (unit Stoken)
#else
  static void CompileString (Stoken) unit Stoken;
#endif

{
  if (DecodeWord (M4NOSTR))
     CompileWord (Stoken, MoveString ());
}


/*
This function compiles a LOOP or +LOOP.
*/

#ifndef ARCHAIC
  static void CompileLoop (unit LoopToken)
#else
  static void CompileLoop (LoopToken) unit LoopToken;
#endif

{
  int link = PairLink (R_DO);

  if (! Object->ErrNo)
     {
       Object->CodeSeg [link].Value = Object->ErrLine;
       CompileWord (LoopToken, link);
     }
}


/*
This function compiles an IF.
*/

#ifndef ARCHAIC
  static void DoIf (void)
#else
  static void DoIf ()
#endif

{
  CompileWord (BRANCH0, 0L);
  MarkLink (R_IF);
}


/*
This function compiles an ELSE.
*/

#ifndef ARCHAIC
  static void DoElse (void)
#else
  static void DoElse ()
#endif

{
  CompileWord (BRANCH, 0L);
  MakeLink (R_IF, LASTW);
  MarkLink (R_IF);
}


/*
This function compiles a THEN.
*/

#ifndef ARCHAIC
  static void DoThen (void)
#else
  static void DoThen ()
#endif

{
  MakeLink (R_IF, LASTW);
}


/*
This function compiles a BEGIN.
*/

#ifndef ARCHAIC
  static void DoBegin (void)
#else
  static void DoBegin ()
#endif

{
  MarkLink (R_BEGIN);
}


/*
This function compiles a WHILE.
*/

#ifndef ARCHAIC
  static void DoWhile (void)
#else
  static void DoWhile ()
#endif

{
  CompileWord (BRANCH0, 0L);
  MarkLink (R_WHILE);
}


/*
This function compiles a REPEAT.
*/

#ifndef ARCHAIC
  static void DoRepeat (void)
#else
  static void DoRepeat ()
#endif

{
  MakeLink (R_WHILE, NEXTW);
  CompileWord (BRANCH, PairLink (R_BEGIN));
}


/*
This function compiles an AGAIN.
*/

#ifndef ARCHAIC
  static void DoAgain (void)
#else
  static void DoAgain ()
#endif

{
  CompileWord (BRANCH, PairLink (R_BEGIN));
}


/*
This function compiles an UNTIL.
*/

#ifndef ARCHAIC
  static void DoUntil (void)
#else
  static void DoUntil ()
#endif

{
  CompileWord (BRANCH0, PairLink (R_BEGIN));
}


/*
This function compiles a ?DO.
*/

#ifndef ARCHAIC
  static void DoQDo (void)
#else
  static void DoQDo ()
#endif

{
  CompileWord (QDO, 0L);
  MarkLink (R_DO);
}


/*
This function compiles a DO.
*/

#ifndef ARCHAIC
  static void DoDo (void)
#else
  static void DoDo ()
#endif

{
  CompileWord (DO, 0L);
  MarkLink (R_DO);
}


/*
This function compiles a LOOP.
*/

#ifndef ARCHAIC
  static void DoLoop (void)
#else
  static void DoLoop ()
#endif

{
  CompileLoop (LOOP);
}


/*
This function compiles a +LOOP.
*/

#ifndef ARCHAIC
  static void DoPLoop (void)
#else
  static void DoPLoop ()
#endif

{
  CompileLoop (PLOOP);
}


/*
This function compiles a ':'.
*/

#ifndef ARCHAIC
  static void DoColon (void)
#else
  static void DoColon ()
#endif

{
  if (DecodeWord (M4NODECL))
     {
       AddSymbol (CALL, Object->ErrLine, CurrentWord);
       CompileWord (BRANCH, 0L);
       MarkLink (R_COLON);
     }
}


/*
This function compiles a ';'.
*/

#ifndef ARCHAIC
  static void DoSColon (void)
#else
  static void DoSColon ()
#endif

{
  CompileWord (EXIT, 0L);
  MakeLink (R_COLON, LASTW);
}


/*
This function compiles a CREATE.
*/

#ifndef ARCHAIC
  static void DoCreate (void)
#else
  static void DoCreate ()
#endif

{
  if (DecodeWord (M4NODECL)) AddSymbol (LITERAL, Object->ErrLine, CurrentWord);
}


/*
This function compiles a VARIABLE.
*/

#ifndef ARCHAIC
  static void DoVariable (void)
#else
  static void DoVariable ()
#endif

{
  if (DecodeWord (M4NODECL))
     AddSymbol (VARIABLE, Object->Variables++, CurrentWord);
}


/*
This function compiles a RECURSE.
*/

#ifndef ARCHAIC
  static void DoRecurse (void)
#else
  static void DoRecurse ()
#endif

{
  int x = ToCS;

  while (x > 0)
    if (ControlStack [--x].Mark == R_COLON)
       {
         CompileWord (CALL, ControlStack [x].Address);
         return;
       }

  Object->ErrNo = M4NONAME;
}


/*
This function compiles a VALUE, IS or TO.
*/

#ifndef ARCHAIC
  static void DoValue (void)
#else
  static void DoValue ()
#endif

{
  cell val;
  int  y;

  if (DecodeWord (M4NODECL))
    {
      if (((y = GetSymbol (CurrentWord, W_SEARCH)) == MISSING)
      || (SymTable [y].Token != VALUE))
         AddSymbol (VALUE, (val = Object->Variables++), CurrentWord);
      else val = SymTable [y].Value;
      CompileWord (TO, val);
    }
}


/*
This function compiles a DEFER or FILE.
*/

#ifndef ARCHAIC
  static void DoInitValue (void)
#else
  static void DoInitValue ()
#endif

{
  CompileWord (LITERAL, CELL_MIN);
  DoValue ();
}


/*
This function compiles a CONSTANT.
*/

#ifndef ARCHAIC
  static void DoConstant (void)
#else
  static void DoConstant ()
#endif

{
  cell val = DecodeSymbol ();
  if (! Object->ErrNo) AddSymbol (LITERAL, val, CurrentWord);
}


/*
This function compiles a STRING.
*/

#ifndef ARCHAIC
  static void DoString (void)
#else
  static void DoString ()
#endif

{
  cell val = DecodeSymbol ();

  if (! Object->ErrNo)
     {
       AddSymbol (LITERAL, (cell) Object->Strings + TIBSIZ + PADSIZ,
                  CurrentWord);
       Object->Strings += (unsigned) val;
     }
}


/*
This function compiles an ARRAY.
*/

#ifndef ARCHAIC
  static void DoArray (void)
#else
  static void DoArray ()
#endif

{
  cell val = DecodeSymbol ();

  if (! Object->ErrNo)
     {
       AddSymbol (VARIABLE, (cell) Object->Variables, CurrentWord);
       Object->Variables += (unsigned) val;
     }
}


/*
This function compiles a '.
*/

#ifndef ARCHAIC
  static void DoTick (void)
#else
  static void DoTick ()
#endif

{
  int  y;

  if (DecodeWord (M4NODECL))
     {
       if ((y = GetSymbol (CurrentWord, W_SEARCH)) == MISSING)
            Object->ErrNo = M4NONAME;
       else CompileWord (LITERAL, SymTable [y].Value);
     }
}


/*
This function compiles a ','.
*/

#ifndef ARCHAIC
  static void DoComma (void)
#else
  static void DoComma ()
#endif

{
  if (Object->ErrLine == 0) Object->ErrNo = M4NODECL;
  else
    if (Object->CodeSeg [Object->ErrLine - 1].Word == LITERAL)
        Object->CodeSeg [Object->ErrLine - 1].Word = NOOP;
    else Object->ErrNo = M4BADLIT;
}


/*
This function compiles comment.
*/

#ifndef ARCHAIC
  static void DoComment (void)
#else
  static void DoComment ()
#endif

{
   (void) DecodeWord (M4NOSTR);
}


/*
This function compiles '."'.
*/

#ifndef ARCHAIC
  static void DoDotQuote (void)
#else
  static void DoDotQuote ()
#endif

{
  CompileString (PRINT);
}


/*
This function compiles a ".
*/

#ifndef ARCHAIC
  static void DoQuote (void)
#else
  static void DoQuote ()
#endif

{
  CompileString (LITERAL);
}


/*
This function compiles a S".
*/

#ifndef ARCHAIC
  static void DoSQuote (void)
#else
  static void DoSQuote ()
#endif

{
  CompileString (SQUOTE);
}


/*
This function sets the radix to 2.
*/

#ifndef ARCHAIC
  static void DoBinary (void)
#else
  static void DoBinary ()
#endif

{
  Base = 2;
}


/*
This function sets the radix to 8.
*/

#ifndef ARCHAIC
  static void DoOctal (void)
#else
  static void DoOctal ()
#endif

{
  Base = 8;
}


/*
This function sets the radix to 10.
*/

#ifndef ARCHAIC
  static void DoDecimal (void)
#else
  static void DoDecimal ()
#endif

{
  Base = 10;
}


/*
This function sets the radix to 16.
*/

#ifndef ARCHAIC
  static void DoHex (void)
#else
  static void DoHex ()
#endif

{
  Base = 16;
}


/*
This function aborts a compilation.
*/

#ifndef ARCHAIC
  static void DoCompAbort (void)
#else
  static void DoCompAbort ()
#endif

{
  Object->ErrNo = M4CABORT;
}


/*
This function evaluates a [=].
*/

#ifndef ARCHAIC
  static void DoEquals (void)
#else
  static void DoEquals ()
#endif

{
  CompileWord (LITERAL, (DecodeLiteral () == DecodeLiteral () ? F_T : F_F));
}


/*
This function executes a [+].
*/

#ifndef ARCHAIC
  static void DoAdd (void)
#else
  static void DoAdd ()
#endif

{
  CompileWord (LITERAL, DecodeLiteral () + DecodeLiteral ());
}


/*
This function executes a [*].
*/

#ifndef ARCHAIC
  static void DoMultiply (void)
#else
  static void DoMultiply ()
#endif

{
  CompileWord (LITERAL, DecodeLiteral () * DecodeLiteral ());
}


/*
This function executes a [NOT].
*/

#ifndef ARCHAIC
  static void DoNot (void)
#else
  static void DoNot ()
#endif

{
  CompileWord (LITERAL, (DecodeLiteral () == F_F ? F_T : F_F));
}


/*
This function executes a [DEFINED].
*/

#ifndef ARCHAIC
  static void DoDefined (void)
#else
  static void DoDefined ()
#endif

{
  if (DecodeWord (M4NODECL))
     CompileWord (LITERAL, (SearchDictionary (CurrentWord, W_SEARCH) == MISSING
     ? F_F : F_T));
}


/*
This function turns on assertion.
*/

#ifndef ARCHAIC
  static void DoAssert (void)
#else
  static void DoAssert ()
#endif

{
  Assert = ! Assert;
}


/*
This function removes an assertion if Assert is false.
*/

#ifndef ARCHAIC
  static void DoAssertion (void)
#else
  static void DoAssertion ()
#endif

{
   if (! Assert) SkipSource ("ASSERT(", ")");
}


/*
This function evaluates an [IF].
*/

#ifndef ARCHAIC
  static void DoBIf (void)
#else
  static void DoBIf ()
#endif

{
   cell val = DecodeLiteral ();
   if (! Object->ErrNo) if (! val) SkipSource ("[IF]", "[THEN]");
}


/*
This function compiles a HERE.
*/

#ifndef ARCHAIC
  static void DoHere (void)
#else
  static void DoHere ()
#endif

{
  CompileWord (LITERAL, (cell) Object->ErrLine);
}


/*
This function does absolutely nothing.
*/

#ifndef ARCHAIC
  static void DoDummy (void) {}
#else
  static void DoDummy () {}
#endif


/*
This function compiles a CHAR or a [CHAR].
*/

#ifndef ARCHAIC
  static void DoChar (void)
#else
  static void DoChar ()
#endif

{
  if (DecodeWord (M4NOSTR)) CompileWord (LITERAL, (cell) CurrentWord [0]);
}


/*
This function compiles a :NONAME.
*/

#ifndef ARCHAIC
  static void DoNoName (void)
#else
  static void DoNoName ()
#endif

{
  CompileWord (LITERAL, Object->ErrLine + 1);
  CompileWord (BRANCH, 0L);
  MarkLink (R_COLON);
}


/*
This function compiles a PLACE
*/

#ifndef ARCHAIC
  static void DoPlace (void)
#else
  static void DoPlace ()
#endif

{
  CompileWord (SWAP, 0L);
  CompileWord (INC, 0L);
  CompileWord (CMOVE, 0L);
}


/*
This function compiles an ABORT"
*/

#ifndef ARCHAIC
  static void DoAbortQuote (void)
#else
  static void DoAbortQuote ()
#endif

{
  CompileWord (BRANCH0, (cell) (Object->ErrLine + 3L));
  CompileString (PRINT);
  CompileWord (CR, 0L);
  CompileWord (QUIT, 0L);
}


/*
This function compiles a WORD
*/

#ifndef ARCHAIC
  static void DoWord (void)
#else
  static void DoWord ()
#endif

{
  CompileWord (DUP, 0L);
  CompileWord (SKIP, 0L);
  CompileWord (TOKEN, 0L);
}


/*
This function compiles a PARSE
*/

#ifndef ARCHAIC
  static void DoParse (void)
#else
  static void DoParse ()
#endif

{
  CompileWord (TOKEN, 0L);
  CompileWord (COUNT, 0L);
}


/*
This function compiles a NIP
*/

#ifndef ARCHAIC
  static void DoNip (void)
#else
  static void DoNip ()
#endif

{
  CompileWord (SWAP, 0L);
  CompileWord (DROP, 0L);
}


/*
This function compiles a TUCK
*/

#ifndef ARCHAIC
  static void DoTuck (void)
#else
  static void DoTuck ()
#endif

{
  CompileWord (SWAP, 0L);
  CompileWord (OVER, 0L);
}


/*
This function compiles a RSHIFT
*/

#ifndef ARCHAIC
  static void DoRshift (void)
#else
  static void DoRshift ()
#endif

{
  CompileWord (NEGATE, 0L);
  CompileWord (SHIFT, 0L);
}


/*
This function compiles a BLANK
*/

#ifndef ARCHAIC
  static void DoBlank (void)
#else
  static void DoBlank ()
#endif

{
  CompileWord (LITERAL, (cell) ' ');
  CompileWord (FILL, 0L);
}


/*
This function compiles an ERASE
*/

#ifndef ARCHAIC
  static void DoErase (void)
#else
  static void DoErase ()
#endif

{
  CompileWord (LITERAL, 0L);
  CompileWord (FILL, 0L);
}


/*
This function compiles a ?
*/

#ifndef ARCHAIC
  static void DoQuestion (void)
#else
  static void DoQuestion ()
#endif

{
  CompileWord (FETCH, 0L);
  CompileWord (DOT, 0L);
}


/*
This function compiles a SPACE
*/

#ifndef ARCHAIC
  static void DoSpace (void)
#else
  static void DoSpace ()
#endif

{
  CompileWord (LITERAL, (cell) ' ');
  CompileWord (EMIT, 0L);
}


/*
This function compiles a CATCH
*/

#ifndef ARCHAIC
  static void DoCatch (void)
#else
  static void DoCatch ()
#endif

{
  CompileWord (CATCH, 0L);
  CompileWord (CAUGHT, 0L);
}


/*
This routine returns the index of the word in the immediate list (if found).
If it is not found in the immediate list it returns MISSING.
*/

#ifndef ARCHAIC
  static int GetImmediate (char *symbol, char mode)
#else
  static int GetImmediate (symbol, mode) char *symbol; char mode;
#endif

{                                  /* list of all "simple" commands */
                                   /* in order of length, important! */
  static Immed4th ImmedList [] =  {
         { 1, "\'", DoTick },
         { 1, "\"", DoQuote },
         { 1, ":", DoColon },
         { 1, ";", DoSColon },
         { 1, "(", DoComment },
         { 1, "?", DoQuestion },
         { 1, "\\", DoComment },
         { 1, ",", DoComma },
         { 2, "#!", DoComment },
         { 2, "IF", DoIf },
         { 2, "DO", DoDo },
         { 2, ".\"", DoDotQuote },
         { 2, ".(", DoDotQuote },
         { 2, "S\"", DoSQuote },
         { 2, "TO", DoValue },
         { 2, "IS", DoValue },
         { 2, "AS", DoValue },
         { 3, "[\']", DoTick },
         { 3, "[+]", DoAdd },
         { 3, "[=]", DoEquals },
         { 3, "[*]", DoMultiply },
         { 3, "S>D", DoDummy },
         { 3, "D>S", DoDummy },
         { 3, "?DO", DoQDo },
         { 3, "NIP", DoNip },
         { 4, "[IF]", DoBIf },
         { 4, "ELSE", DoElse },
         { 4, "THEN", DoThen },
         { 4, "LOOP", DoLoop },
         { 4, "HERE", DoHere },
         { 4, "TUCK", DoTuck },
         { 4, "WORD", DoWord },
         { 4, "CHAR", DoChar },
         { 4, "FILE", DoInitValue },
         { 5, "DEFER", DoInitValue },
         { 5, "+LOOP", DoPLoop },
         { 5, "ARRAY", DoArray },
         { 5, "PLACE", DoPlace },
         { 5, "PARSE", DoParse },
         { 5, "BEGIN", DoBegin },
         { 5, "WHILE", DoWhile },
         { 5, "AGAIN", DoAgain },
         { 5, "UNTIL", DoUntil },
         { 5, "VALUE", DoValue },
         { 5, "CELLS", DoDummy },
         { 5, "CHARS", DoDummy },
         { 5, "ALIGN", DoDummy },
         { 5, "CATCH", DoCatch },
         { 5, "SPACE", DoSpace },
         { 5, "[NOT]", DoNot },
         { 5, "[HEX]", DoHex },
         { 5, "TABLE", DoCreate },
         { 5, "BLANK", DoBlank },
         { 5, "ERASE", DoErase },
         { 6, "CREATE", DoCreate },
         { 6, "[THEN]", DoDummy },
         { 6, "[CHAR]", DoChar },
         { 6, "[NEEDS", DoComment },
         { 6, "REPEAT", DoRepeat },
         { 6, "STRING", DoString },
         { 6, "RSHIFT", DoRshift },
         { 6, "ABORT\"", DoAbortQuote },
         { 7, ":NONAME", DoNoName },
         { 7, "ASSERT(", DoAssertion },
         { 7, "[ABORT]", DoCompAbort },
         { 7, "[OCTAL]", DoOctal },
         { 7, "ALIGNED", DoDummy },
         { 7, "RECURSE", DoRecurse },
         { 8, "CONSTANT", DoConstant },
         { 8, "VARIABLE", DoVariable },
         { 8, "[ASSERT]", DoAssert },
         { 8, "[BINARY]", DoBinary },
         { 9, "[DECIMAL]", DoDecimal },
         { 9, "[DEFINED]", DoDefined },
         { CHAR_MAX, "", DoDummy }     /* terminator of wordlist */
  };

  int x;                               /* simple counter */
  unsigned len = strlen (symbol);

  for (x = 0; len > ImmedList [x].Ilen; x++);
  for (;len == ImmedList [x].Ilen; x++)
      if (! MatchName (ImmedList [x].Iname, symbol))
         {
           if (mode == W_EXEC) (*(ImmedList [x].Ifun)) ();
           return (x);
         }

  return (MISSING);
}


/*
This routine returns the index of the word in the wordlist (if found).
If it is not found in the wordlist it returns MISSING.
*/

#ifndef ARCHAIC
  static int GetWord (char *symbol, char mode)
#else
  static int GetWord (symbol, mode) char *symbol; char mode;
#endif

{                                      /* list of all "simple" commands */
                                       /* in order of length, important! */
  static Word4th WordList [] =  {
         { 1, ".", DOT },
         { 1, "@", FETCH },
         { 1, "!", STORE },
         { 1, "+", PLUS },
         { 1, "-", MINUS },
         { 1, "*", MUL },
         { 1, "/", DIV },
         { 1, "=", EQ },
         { 1, ">", GT },
         { 1, "<", LT },
         { 1, ")", CLSPAREN },
         { 1, "I", RCOPY },
         { 1, "J", RCOPY3 },
         { 1, "#", SHARP },
         { 2, "CR", CR },
         { 2, "C@", CFETCH },
         { 2, "C!", CSTORE },
         { 2, ">=", GE },
         { 2, "<=", LE },
         { 2, "*/", STARSLSH },
         { 2, "@\'", FETCHPRM },
         { 2, "<>", NE },
         { 2, "0<", LT0 },
         { 2, "0>", GT0 },
         { 2, "TH", PLUS },
         { 2, ">R", RPUT },
         { 2, "R>", RGET },
         { 2, "R@", RCOPY },
         { 2, ".R", DOTR },
         { 2, "<#", LSHARP },
         { 2, "1+", INC },
         { 2, "1-", DEC },
         { 2, "2*", LEFT2 },
         { 2, "2/", RIGHT2 },
         { 2, "0=", EQ0 },
         { 2, "+!", ADDSTORE },
         { 2, "OR", OR },
         { 2, "HI", HI },
         { 2, "#>", RSHARP },
         { 2, "#S", SHARPS },
         { 3, "0<>", NE0 },
         { 3, "MOD", MOD },
         { 3, "DUP", DUP},
         { 3, "RP@", RPFETCH },
         { 3, "SP@", SPFETCH },
         { 3, "ROT", ROT },
         { 3, "AND", AND },
         { 3, "XOR", XOR },
         { 3, "ABS", ABS },
         { 3, "MIN", MIN },
         { 3, "MAX", MAX },
         { 3, "HEX", HEX },
         { 3, "USE", USE },
         { 4, "COPY", COPY },
         { 4, "HOLD", HOLD },
         { 4, "SIGN", SIGN },
         { 4, "EXIT", EXIT },
         { 4, "/MOD", SLASHMOD },
         { 4, "TIME", TIME },
         { 4, "EMIT", EMIT },
         { 4, "OVER", OVER },
         { 4, "SWAP", SWAP },
         { 4, "WAIT", WAIT },
         { 4, "TYPE", TYPE },
         { 4, "FILL", FILL },
         { 4, "SKIP", SKIP },
         { 4, "DROP", DROP },
         { 4, "QUIT", QUIT },
         { 4, "MOVE", CMOVE },
         { 4, "LAST", LAST },
         { 4, "OPEN", FOPEN },
         { 4, "ARGS", ARGS },
         { 4, "ARGN", ARGN },
         { 5, "ABORT", QUIT },
         { 5, "TOKEN", TOKEN },
         { 5, "CLOSE", FCLOSE },
         { 5, "FIRST", FIRST },
         { 5, "CHAR+", INC },
         { 5, "CHAR-", DEC },
         { 5, "CELL+", INC },
         { 5, "CELL-", DEC },
         { 5, "DEPTH", SPFETCH },
         { 5, "COUNT", COUNT },
         { 5, "CMOVE", CMOVE },
         { 5, "*/MOD", STSLHMOD },
         { 5, "SHIFT", SHIFT },
         { 5, "LEAVE", LEAVE },
         { 5, "OCTAL", OCTAL },
         { 5, "THROW", THROW },
         { 6, "REFILL", REFILL },
         { 6, "CMOVE>", CMOVE },
         { 6, "SPACES", SPACES },
         { 6, "NUMBER", NUMBER },
         { 6, "LSHIFT", SHIFT },
         { 6, "NEGATE", NEGATE },
         { 6, "ACCEPT", ACCEPT },
         { 6, "INVERT", INVERT },
         { 6, "RANDOM", RANDOM },
         { 7, "EXECUTE", EXECUTE },
         { 7, "DECIMAL", DECIMAL },
         { 9, "-TRAILING", TRAILING },
         { CHAR_MAX, "", NOOP }        /* terminator of wordlist */
  };

  int x;                               /* simple counter */
  unsigned len = strlen (symbol);

  for (x = 0; len > WordList [x].Wlen; x++);
  for (;len == WordList [x].Wlen; x++)
      if (! MatchName (WordList [x].Wname, symbol))
         {
           if (mode == W_EXEC) CompileWord (WordList [x].Wtok, 0L);
           return (x);
         }

  return (MISSING);
}


/*
This routine returns the index of the word in the constlist (if found).
If it is not found in the constlist it returns MISSING.
*/

#ifndef ARCHAIC
  static int GetConstant (char *symbol, char mode)
#else
  static int GetConstant (symbol, mode) char *symbol; char mode;
#endif

{
  static Const4th ConstList [] =  {
         { 2, "BL", (cell) ' ' },
         { 2, "LO", PADSIZ+TIBSIZ },
         { 3, "TIB", TIB },
         { 3, "PAD", PAD },
         { 3, ">IN", 1L },
         { 3, "APP", VAR4TH },
         { 4, "/PAD", PADSIZ },
         { 4, "/TIB", TIBSIZ },
         { 4, "BASE", 0L },
         { 4, "TRUE", F_T },
         { 4, "VARS", 0L },
         { 4, "TEXT", F4_TEXT },
         { 4, "PIPE", F4_PIPE },
         { 5, "/CELL", (cell) sizeof (cell) },
         { 5, "/CHAR", (cell) sizeof (unit) },
         { 5, "FALSE", F_F },
         { 5, "WIDTH", SYMLEN - 1 },
         { 5, "MAX-N", CELL_MAX },
         { 5, "INPUT", F4_READ },
         { 5, "STDIN", F4_READ },
         { 6, "STDOUT", F4_WRITE },
         { 6, "OUTPUT", F4_WRITE },
         { 6, "APPEND", F4_APPND },
         { 6, "RESULT", 2L },
         { 7, "(ERROR)", CELL_MIN },
         { 8, "MAX-RAND", RNDMASK },
         { 11, "STACK-CELLS", STACKSIZ },
         { CHAR_MAX, "", 0L }          /* terminator of constant list */
  };

  int x;                               /* simple counter */
  unsigned len = strlen (symbol);

  for (x = 0; len > ConstList [x].Clen; x++);
  for (;len == ConstList [x].Clen; x++)
      if (! MatchName (ConstList [x].Cname, symbol))
         {
           if (mode == W_EXEC) CompileWord (LITERAL, ConstList [x].Cval);
           return (x);
         }

  return (MISSING);
}


/*
This routine searches the entire dictionary for a specific name and performs
the action as indicated.
*/

#ifndef ARCHAIC
  static int SearchDictionary (char* Name, char Action)
#else
  static int SearchDictionary (Name, Action) char* Name; char Action;
#endif

{
  if ((GetWord     (Name, Action) == MISSING)
  && (GetConstant  (Name, Action) == MISSING)
  && (GetImmediate (Name, Action) == MISSING)
  && (GetSymbol    (Name, Action) == MISSING))
       return (MISSING);
  else return (FOUND);
}


/*
This routine will add a symbol to the symboltable. It checks on overflow.
It sets Object->ErrNo to the appropriate number when it fails.
*/

#ifndef ARCHAIC
  static void AddSymbol (unit Stoken, cell Svalue, char* Sname)
#else
  static void AddSymbol (Stoken, Svalue, Sname)
         unit Stoken; cell Svalue; char* Sname;
#endif

{
  if (SymTablep < SourceSymbols)
    if (SearchDictionary (Sname, W_SEARCH) == MISSING)
       {
         SymTable [SymTablep].Token = Stoken;
         SymTable [SymTablep].Value = Svalue;
         SymTable [SymTablep].Name [SYMLEN - 1] = '\0';
         strncpy (SymTable [SymTablep++].Name, Sname, SYMLEN - 1);
       }
    else Object->ErrNo = M4DUPNAM;
  else Object->ErrNo = M4BADOBJ;
}


/*
This routine simply frees the memory allocated to the symboltable and
the linktable. It resets the pointers too, so it can be called again
without any problem.
*/

#ifndef ARCHAIC
  static void FreeResource (void)
#else
  static void FreeResource ()
#endif

{
  if (ControlStack)
     {
       free (ControlStack);
       ControlStack = NULL;
     }

  if (SymTable)
     {
       free (SymTable);
       SymTable = NULL;
     }
}


/*
This routine aborts the current compile, cleans up and returns the header.
*/

#ifndef ARCHAIC
  static Hcode* AbortCompile (void)
#else
  static Hcode* AbortCompile ()
#endif

{
  FreeResource ();

  if (Object->CodeSeg)
     {
       free (Object->CodeSeg);
       Object->CodeSiz = 0;
       Object->CodeSeg = NULL;
     }

  if (Object->StringSeg)
     {
       free (Object->StringSeg);
       Object->StringSiz = 0;
       Object->StringSeg = NULL;
     }

  Object->Reliable = FALSE;

  return (Object);
}


/*
Initializes the object and all global variables
*/

#ifndef ARCHAIC
  static int InitObject (char* sources)
#else
  static int InitObject (sources) char* sources;
#endif

{
  Assert           = FALSE;            /* assertion turned off */
  Base             = 10;               /* set radix to decimal */
  ToCS             = 0;                /* top of Control Stack */
  SymTablep        = 0;                /* top of symbol table */
  SourceSymbols    = 0;                /* size of symbol table */
  SourceStrings    = 0;                /* number of individual strings */
  SourceCorrection = 0;                /* correction for word allocation */
  CompiledStrings  = 0;                /* reset counter of compiled words */
  ControlStack     = NULL;             /* pointer to Control Stack */
  SymTable         = NULL;             /* pointer to symbol table */

  Object->StringSeg = sources;
  Object->CodeSeg   = NULL;
  Object->StringSiz = 0;
  Object->Variables = 0;
  Object->Strings   = 0;
  Object->ErrNo     = M4NOERRS;        /* reset variables in header */
  Object->ErrLine   = 0;
  return ((Object->CodeSiz = ParseText ()));
}


/*
This routine allocates all necessary resources like symboltable, linktable
and the codesegment. The value of ErrNo is returned.
*/

#ifndef ARCHAIC
  static unsigned AllocResource (void)
#else
  static unsigned AllocResource ()
#endif

{
  if ((Object->CodeSeg = (dict*)
     calloc (Object->CodeSiz, sizeof (dict))) == NULL)
     Object->ErrNo = M4NOMEM;

  if (SourceSymbols)
     if ((SymTable = (Symbol*) calloc (SourceSymbols, sizeof(Symbol))) == NULL)
        Object->ErrNo = M4NOMEM;

  if ((ControlStack = (Link*) calloc (LINKSIZ, sizeof (Link))) == NULL)
     Object->ErrNo = M4NOMEM;

  return (Object->ErrNo);
}


/*
This routine reallocates the String Segment and Code Segment. It returns FALSE
when everything is all right.
*/

#ifndef ARCHAIC
  static char ReallocSegs (void)
#else
  static char ReallocSegs ()
#endif

{
  dict *Dp;
  char *Sp;

  FreeResource ();                     /* free link- and symboltables */

  if (Object->StringSiz == 0)          /* discard String Segment */
     {                                 /* when there are no strings */
       free (Object->StringSeg);
       Object->StringSeg = NULL;
     }
  else                                 /* adjust String Segment */
     if ((Sp = (char*) realloc (Object->StringSeg,
        Object->StringSiz * sizeof (char))) != NULL) Object->StringSeg = Sp;
     else                              /* if realloc fails, free segment */
        {
          Object->ErrNo = M4NOMEM;
          return (TRUE);
        }
                                       /* check if program */
  if ((Object->CodeSiz = Object->ErrLine) == 0)
     {
       if (! Object->ErrNo) Object->ErrNo = M4NOPROG;
       return (TRUE);
     }
  else                                 /* adjust Code Segment */
     if ((Dp = (dict*) realloc (Object->CodeSeg,
        Object->CodeSiz * sizeof (dict))) != NULL) Object->CodeSeg = Dp;
     else                              /* if realloc fails, free segment */
        {
          Object->ErrNo = M4NOMEM;
          return (TRUE);
        }

  return (FALSE);
}


#ifndef ARCHAIC
  Hcode *comp_4th (char *Source)
#else
  Hcode *comp_4th (Source) char *Source;
#endif

{
  cell     Value;                      /* temporary cell value */
  char    *p;                          /* temporary char pointer */

  if ((Object = (Hcode*) calloc (1, sizeof (Hcode))) == NULL)
    {
      free (Source);
      return (NULL);                   /* allocate objectheader */
    }
                                       /* initialize header */
  if (InitObject (Source) < 1) return (AbortCompile ());
  if (AllocResource ())        return (AbortCompile ());
                                       /* allocate all resources */
  Cursor = Object->StringSeg; GetNextWord ();
                                       /* initialize parser */
  for (;(CurrentWord != NULL) && (! Object->ErrNo); GetNextWord ())
      {
        if (SearchDictionary (CurrentWord, W_EXEC) == MISSING)
           {
             Value = strtoc (CurrentWord, &p, Base);
             if (p == (CurrentWord + strlen (CurrentWord)))
                CompileWord (LITERAL, Value);
             else Object->ErrNo = M4NONAME;
           }
      }                                /* now compile */
                                       /* reallocate segments */
  if (ReallocSegs ()) return (AbortCompile ());
  if ((ToCS != 0) && (! Object->ErrNo)) Object->ErrNo = M4NOJUMP;
                                       /* check empty linktable */
  Object->Reliable = Object->ErrNo ? FALSE : TRUE;
  return (Object);                     /* return compiled code */
}








